% Some examples for the iterative deepening interpreter.

module idfstest.

import idfs.

type    membb           A -> list A -> goal.
type    memb1           goal -> goal -> o.
type    memb2           goal -> goal -> o.
type    idfs1           A -> list A -> int -> int -> int -> o.
type    idfs2           A -> list A -> int -> int -> o.

memb1 (membb A (A::T)) tt.
memb2 (membb A (B::T)) (membb A T).

idfs1 A Lis Bnd Incr UpBnd :-
   idfs_interpb Bnd Incr UpBnd (memb1::memb2::nil) (membb A Lis).
idfs2 A Lis Bnd Incr :-
   idfs_interp Bnd Incr (memb1::memb2::nil) (membb A Lis).

kind    i               type.
type    aa              i.
type    bb              i.
type    cc              i.
type    dd              i.
type    ee              i.
type    test            int -> i -> o.

test 1 A :- idfs1 A (aa::bb::cc::aa::dd::ee::aa::nil) 1 2 6.
test 2 A :- idfs2 A (aa::bb::cc::aa::dd::ee::aa::nil) 2 1.
